import lrg.jMondrian.figures.*;
import lrg.jMondrian.painters.*;
import lrg.jMondrian.layouts.*;
import lrg.jMondrian.commands.*;
import lrg.jMondrian.view.*;
import lrg.jMondrian.util.*;

import java.util.*;

public class Main {

	public static void main(String argv[]) {
		Numar nr1 = new Numar(5);
		Numar nr2 = new Numar(6);
		Numar nr3 = new Numar(0);
		Suma  sum = new Suma(nr1,nr2);
		Inmultire prod = new Inmultire(sum,nr3);
		
		List<Object> nodes = new ArrayList<Object>();
		nodes.add(nr1);
		nodes.add(nr2);
		nodes.add(nr3);
		nodes.add(sum);
		nodes.add(prod);
		List<Object> edges = new ArrayList<Object>();
		edges.add(new RelationPlaceholder(nr1,sum));
		edges.add(new RelationPlaceholder(nr2,sum));
		edges.add(new RelationPlaceholder(sum,prod));
		edges.add(new RelationPlaceholder(nr3,prod));

		Figure f = new Figure();
		f.nodesUsing(nodes, new RectangleNodePainter(50,50,true).name(new AbstractStringCommand("Expression") {
			public String execute() {
				return receiver.toString();
			}		
		}));
		f.edgesUsing(edges, new LineEdgePainter(new AbstractEntityCommand() {
			public Object execute() {
				return ((RelationPlaceholder)receiver).getSource();
			}
		}, new AbstractEntityCommand() {
			public Object execute() {
				return ((RelationPlaceholder)receiver).getDestination();
			}		
		}));
		f.layout(new CrossReductionTreeLayout());

		ViewRenderer v = new ViewRenderer();
		f.renderOn(v);
		v.open();
	}
}